package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrOtherInfo36;
import com.zksy.data.domain.response.XcrOtherInfo36Response;
import com.zksy.data.mapper.XcrOtherInfo36Mapper;
import com.zksy.data.service.XcrOtherInfo36Service;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_other_info_36(水费清单表)】的数据库操作Service实现
* @createDate 2024-10-14 18:18:54
*/
@Service
@Slf4j
public class XcrOtherInfo36ServiceImpl extends ServiceImpl<XcrOtherInfo36Mapper, XcrOtherInfo36>
    implements XcrOtherInfo36Service{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Override
    @Transactional(rollbackFor = Exception.class)
    @XhDataLogRecord("同步水费清单表")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrOtherInfo36> toDatabaseList = new Vector<>();
        List<String> inventoryList = List.of("36");
        inventoryList.parallelStream().forEach(inventory -> {
            creditCodes.parallelStream().limit(1000).forEach(creditCode -> {
                HashMap<String, String> requestbodyMap = new HashMap<>();
                requestbodyMap.put("entityCode", creditCode);
                requestbodyMap.put("size", String.valueOf(10));
                requestbodyMap.put("page", String.valueOf(1));
                requestbodyMap.put("inventoryId", inventory);
                try {
                    List<XcrOtherInfo36> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrOtherInfo36Response.class,
                            XcrOtherInfo36.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                } catch (Exception e) {
                    List<XcrOtherInfo36> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrOtherInfo36Response.class,
                            XcrOtherInfo36.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                }
            });
            log.info("inventorywe为:{}完成",inventory);
        });
        this.remove(null);
        this.saveBatch(toDatabaseList);
        log.info("水费清单表同步完成");
    }
}




